//+------------------------------------------------------------------+
//|                 Konkistadorr Empty EA for Binary Option test.mq4 |
//|                            Copyright 2016, Konkistadorr          |
//|                                                                  |
//| This is a Free EA, given to community (BinaryOptionsEdge)        |
//| People can modify it, share it, but never sell it.               |
//| Email : konkistadorr@gmail.com                                   |
//+------------------------------------------------------------------+

/*

v1.5: 
   - Fix new bar issue

v 1.4:
   - Adding a line for entry price
   - Add Opening choice : Every Tick, or Candle Open
   - Add time of expiration : End of candle or Fixed time

v 1.3:
   - Time Management : Setting Start and Stop hours

v 1.2 :
   - fix bug on Candle Shift on Higher Time Frame
   - Add Martingale on Next Entry Candle
   - Improve HMI Text informations
   - Improve quick test when no visual mode

v 1.1 :
  - bug fix causing crash when total of trades was 0 : OK
  - Adding any time frame to backtest, not only M1 : OK
  - Journal to log the results instead of using visual mode : OK
  - Displaying the max consecutives wins/loss candles : OK
  
v 1.0 :
   - Simple backtest
   - HMI with : Wins, Losses, Draws and Win Rates
   - Arrows, Stops, and Check on chart
*/
#property copyright "Copyright 2016, Konkistadorr."
#property link      ""
#property version   "1.5"
#property strict


//+------------------------------------------------------------------+
//| internal variables                           
//+------------------------------------------------------------------+
enum EntryType
  {
   EachTick=0,     // Each Tick
   OpenOfCandle=1,     // Open of new candle
  };
  
enum ExpirationType
  {
   FixedTime=0,       // Fixed Time (ex: 15 mins)
   EndOfCandle=1,     // End of Candle
  };

extern string mAccountTitle="  --== Account parameters ==--  ";
extern double mAccountBalance=100.0;// Account Balance
extern double mPayout=80;           // Binary Option Payout (Percent)
extern double mInvestment=1.0;      // Investment for each trade

extern string mEntryTitle="  --== Entry & Expiry ==--  ";
input EntryType mEntryType = OpenOfCandle;
input ExpirationType mExpirationType = EndOfCandle; // Expiration type
extern int    mHigherTimeFrameCandleShift=1; // Expiration After X Candles (1:Current for EndOfCandle)
extern int    mExpirationTime = 5; // Expiration Time (Mins and for Fixed Time)

extern string cTimingString=" -------====== Time =======-------";
extern bool   cEnableTiming; // Enable Trading Time
extern double cStartingTime=0.0; // Starting Time (Ex : 16.10)
extern double cStopingTime=24.0; // Ending Time (Ex : 18.45)

extern string mMartingaleTitle="  --== Martingale ==--  ";
extern bool   mUseMartingale = false; // Use Martingale
extern int    mMartingaleStep = 1;    // Max Consecutives trades
extern double mInvestment1 = 1.0;     // Investment on 1st Trade
extern double mInvestment2 = 3.0;     // Investment on 2nd Trade
extern double mInvestment3 = 8.0;     // Investment on 3rd Trade
extern double mInvestment4 = 18.0;    // Investment on 4th Trade
extern double mInvestment5 = 40.0;    // Investment on 4th Trade

extern string mLogTitle="  --== Logs ==--  ";
extern bool   mUseLogs=false; // Enable Logs

//+------------------------------------------------------------------+
//| Local Variables                                                        |
//+------------------------------------------------------------------+

double mCallPrice= 0.0;
double mPutPrice = 0.0;

// Price value of the previous break (vbid price)
bool   mBetPending=false;

// Bet Status : Call or Put
/*
 * : 1 Put in progress
 * : 2 Call in progress
*/
string mBetStatus="";
bool   mAskForPendingReset=false;

//IHM variables
int   mSellOrderObjectsNumber= 0;
int   mBuyOrderObjectsNumber = 0;
int   mObjectsArrowStopNumber = 0;
int   mObjectsArrowCheckNumber=0;
int   mObjectsThumbUpNumber=0;
int   mLineObjectsNumber=0;

int   mMaxConsecutivesWins=0;
int   mMaxConsecutivesLosses=0;

int   mMaxConsecutivesWinsTemp=0;
int   mMaxConsecutivesLossesTemp=0;

int   mNbWins = 0;
int   mNbLoss = 0;
int   mNbDraws= 0;

// Working with higher time frame
int   mCandleElapsed=0;

// Martingale
int   mTryTimes=0;

datetime New_Time=0;
datetime mEntryTime = 0;

string mStartTime;
string mStopTime;
//+------------------------------------------------------------------+
//|                   ENTRY POINTS !                                 |
//| PUT YOUR RULES HERE  :=)                                         |
//+------------------------------------------------------------------+
bool checkEntryPoint(bool  &pIsDirectionUp)
  {

//*****
// Refresh your indicators here
// Ex : double RSI4 = iRSI(NULL, 0, 4, PRICE_CLOSE, 0);
//*****  
   double lBBUp = iBands(NULL, PERIOD_CURRENT, 20, 3, 0, PRICE_CLOSE, MODE_UPPER, 0);
   double lBBDown =  iBands(NULL, PERIOD_CURRENT, 20, 3, 0, PRICE_CLOSE, MODE_LOWER, 0);

//****
// WRITE HERE THE CONDITION FOR OPENING A PUT Binary Otions
// Ex : if (RSI4<10.0)
//****
   if
//( WRITE YOUR PUT RULES HERE )
   ( false )
     {
      pIsDirectionUp=false;
      return true;
     }

//****
// WRITE HERE THE CONDITION FOR OPENING A CALL BO
// Ex : if (RSI4>90.0)
//****
   if
//( WRITE YOUR CALL RULES HERE )
   ( true ) 
     {
      pIsDirectionUp=true;
      return true;
     }

   return false;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(60);
   Print("---- Konkistadorr Robot for Binary Options -----");

// Charts customization
   ChartSetInteger(ChartID(),CHART_MODE,CHART_CANDLES);
   ChartSetInteger(ChartID(),CHART_COLOR_GRID,C'27,54,54');
   ChartSetInteger(ChartID(),CHART_COLOR_CANDLE_BEAR,clrDarkGray);
   ChartSetInteger(ChartID(),CHART_COLOR_CANDLE_BULL,clrLimeGreen);
   ChartSetInteger(ChartID(),CHART_COLOR_CHART_UP,clrLimeGreen);
   ChartSetInteger(ChartID(),CHART_COLOR_CHART_DOWN,clrGray);

   if(!ChartSetInteger(ChartID(),CHART_SCALE,0,4))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }

// HUD Text
   displayText("Konkistadorr Binary Options Tester v1.5",0,clrCyan);

   if(mUseMartingale)
      displayTextDownLeft("Martingale : ON ("+IntegerToString(mMartingaleStep)+"), Candle Shift "+IntegerToString(mHigherTimeFrameCandleShift),1,clrGray);
   else
      displayTextDownLeft("Martingale : OFF, Candle Shift "+IntegerToString(mHigherTimeFrameCandleShift),1,clrGray);

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

   displayJournal();

//--- destroy timer
   EventKillTimer();
   Print("---- Konkistadorr Robot to test Binary Options...-----");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  


// Check that there is enough data to test
   if(Bars<50)
     {
      return;
     }

   bool lNewBar=New_Bar();
   
// Only start trading at new bar opening
   if(lNewBar)
     {
      // Work on which candle time frame ?
      mCandleElapsed++;
      
      if(   (mExpirationType == EndOfCandle && mCandleElapsed>=mHigherTimeFrameCandleShift)
          || (mExpirationType == FixedTime && TimeCurrent()-mEntryTime>=(mExpirationTime*60) )
          )
        {

         //********
         //
         // Start checking Previous candles trade
         //
         //********
         if
         (mBetPending && mBetStatus=="Put")
           {

            mAskForPendingReset=true;
            drawArrowDown();

            // Now is the result : win or loose ?
            if(Close[1]<mPutPrice)
              {
               // Won !
               if(mUseMartingale)
                 {
                  if(mTryTimes==1) mAccountBalance=mAccountBalance+mInvestment1*(mPayout/100.0+1.0);
                  else if( mTryTimes == 2 ) mAccountBalance = mAccountBalance+mInvestment2*(mPayout/100.0+1.0);
                  else if( mTryTimes == 3 ) mAccountBalance = mAccountBalance+mInvestment3*(mPayout/100.0+1.0);
                  else if( mTryTimes == 4 ) mAccountBalance = mAccountBalance+mInvestment4*(mPayout/100.0+1.0);
                  else if( mTryTimes == 5 ) mAccountBalance = mAccountBalance+mInvestment5*(mPayout/100.0+1.0);
                 }
               else
                 {
                  mAccountBalance=mAccountBalance+mInvestment*(mPayout/100.0+1.0);
                 }

               if(mUseLogs) Print("  => Won : Account balance : "+DoubleToStr(mAccountBalance));

               resetVariables();

               mNbWins=mNbWins+1;

               mTryTimes=0;

               // Consecutives Wins
               mMaxConsecutivesLossesTemp=0;
               mMaxConsecutivesWinsTemp++;
               if(mMaxConsecutivesWinsTemp>mMaxConsecutivesWins)
                 {
                  mMaxConsecutivesWins=mMaxConsecutivesWinsTemp;
                 }

               drawArrowCheck(false);

              }
            else if(Close[1]>mPutPrice)
              {
               // Looose  !
               resetVariables();
               mNbLoss=mNbLoss+1;

               // Consecutives losses
               mMaxConsecutivesWinsTemp=0;
               mMaxConsecutivesLossesTemp++;
               if(mMaxConsecutivesLossesTemp>mMaxConsecutivesLosses)
                 {
                  mMaxConsecutivesLosses=mMaxConsecutivesLossesTemp;
                 }

               if(mUseLogs) Print("  => Loose : Account balance : "+DoubleToStr(mAccountBalance));

               drawArrowStop(false);
              }
            else
              {
               // Draw HERE : Start Again
               if(mUseMartingale)
                 {
                  if(mTryTimes==1) mAccountBalance=mAccountBalance+mInvestment1;
                  else if( mTryTimes == 2 ) mAccountBalance = mAccountBalance+mInvestment2;
                  else if( mTryTimes == 3 ) mAccountBalance = mAccountBalance+mInvestment3;
                  else if( mTryTimes == 4 ) mAccountBalance = mAccountBalance+mInvestment4;
                  else if( mTryTimes == 5 ) mAccountBalance = mAccountBalance+mInvestment5;
                 }
               else
                 {
                  mAccountBalance=mAccountBalance+mInvestment;
                 }

               resetVariables();

               mNbDraws=mNbDraws+1;

               // Decrease this try because it's not really one

               mTryTimes--;
               if(mUseLogs) Print("  => Draw : Account balance : "+DoubleToStr(mAccountBalance));

               drawDraw(false);
              }
           }
         else if
         (mBetPending && mBetStatus=="Call")
           {

            mAskForPendingReset=true;
            drawArrowUp();

            // Now is the result : win or loose ?
            if(Close[1]>mCallPrice)
              {
               // Won !
               if(mUseMartingale)
                 {
                  if(mTryTimes==1) mAccountBalance=mAccountBalance+mInvestment1*(mPayout/100.0+1.0);
                  else if( mTryTimes == 2 ) mAccountBalance = mAccountBalance+mInvestment2*(mPayout/100.0+1.0);
                  else if( mTryTimes == 3 ) mAccountBalance = mAccountBalance+mInvestment3*(mPayout/100.0+1.0);
                  else if( mTryTimes == 4 ) mAccountBalance = mAccountBalance+mInvestment4*(mPayout/100.0+1.0);
                  else if( mTryTimes == 5 ) mAccountBalance = mAccountBalance+mInvestment5*(mPayout/100.0+1.0);
                 }
               else
                 {
                  mAccountBalance=mAccountBalance+mInvestment*(mPayout/100.0+1.0);
                 }

               if(mUseLogs) Print("  => Won : Account balance : "+DoubleToStr(mAccountBalance));

               resetVariables();
               mNbWins=mNbWins+1;

               mTryTimes=0;

               // Consecutives wins
               mMaxConsecutivesLossesTemp=0;
               mMaxConsecutivesWinsTemp++;
               if(mMaxConsecutivesWinsTemp>mMaxConsecutivesWins)
                 {
                  mMaxConsecutivesWins=mMaxConsecutivesWinsTemp;
                 }

               drawArrowCheck(true);

              }
            else if(Close[1]<mCallPrice)
              {
               // Loose !
               resetVariables();
               mNbLoss=mNbLoss+1;

               // Consecutives losses
               mMaxConsecutivesWinsTemp=0;
               mMaxConsecutivesLossesTemp++;
               if(mMaxConsecutivesLossesTemp>mMaxConsecutivesLosses)
                 {
                  mMaxConsecutivesLosses=mMaxConsecutivesLossesTemp;
                 }

               if(mUseLogs) Print("  => Loose : Account balance : "+DoubleToStr(mAccountBalance));

               drawArrowStop(true);

              }
            else
              {
               // Draw HERE : Start Again
               if(mUseMartingale)
                 {
                  if(mTryTimes==1) mAccountBalance=mAccountBalance+mInvestment1;
                  else if( mTryTimes == 2 ) mAccountBalance = mAccountBalance+mInvestment2;
                  else if( mTryTimes == 3 ) mAccountBalance = mAccountBalance+mInvestment3;
                  else if( mTryTimes == 4 ) mAccountBalance = mAccountBalance+mInvestment4;
                  else if( mTryTimes == 5 ) mAccountBalance = mAccountBalance+mInvestment5;
                 }
               else
                 {
                  mAccountBalance=mAccountBalance+mInvestment;
                 }

               resetVariables();

               mNbDraws=mNbDraws+1;

               // Decrease this try because it's not really one
               mTryTimes--;
               if(mUseLogs) Print("  => Draw : Account balance : "+DoubleToStr(mAccountBalance));

               drawDraw(true);
              }
           }
        }
      else
        {
         //Print(" Skip the candle !");
        }
     }
//
//
//  CHECK NEW ENTRY HERE
//
//

// Check if there is already an Order in progres..
   bool lCheckEntry = false;
   if ( mEntryType == EachTick )
      lCheckEntry = true;
   else if ( mEntryType == OpenOfCandle && lNewBar)
      lCheckEntry = true;

   if(mBetPending==false && lCheckEntry)
     {

      // Current server time : store it as double ( integer : hours / decimal : minutes)
      double lCurrentTime=Hour()+Minute()/100; // Current time
      if(!cEnableTiming || (lCurrentTime>=cStartingTime && lCurrentTime<=cStopingTime))
        {
         bool lIsDirectionUp;
         bool lEntryFound=checkEntryPoint(lIsDirectionUp);

         //Reset candle timer
         mCandleElapsed=0;

         if(lEntryFound)
           {
            
            mEntryTime = TimeCurrent();
           
            if
            (lIsDirectionUp)
              {
               // Placing a Call Option
               mBetPending= true;
               mBetStatus = "Call";

               // Store the "Call" Price : warning don't forget there is a time between NOW and the order proceed time
               mCallPrice=Bid;

               // Create line on chart when entry is not at the beginning of the candle
               drawEntryLine(true);
              }
            else
              {
               // Placing a Put Option
               mBetPending= true;
               mBetStatus = "Put";

               // Store the "Put" Price : warning don't forget there is a time between NOW and the order proceed time
               mPutPrice=Bid;

               // Create line on chart when entry is not at the beginning of the candle
               drawEntryLine(false);

              }

            //*********
            //Decrease Account balance : Martingale or not ?
            //*********
            if(mUseMartingale)
              {
               mTryTimes++;
               if(mTryTimes>mMartingaleStep)
                 {
                  mTryTimes=1; // One because we will enter a new trade here
                 }

               if(mTryTimes==1) mAccountBalance=mAccountBalance-mInvestment1;
               else if( mTryTimes == 2 ) mAccountBalance=mAccountBalance-mInvestment2;
               else if( mTryTimes == 3 ) mAccountBalance=mAccountBalance-mInvestment3;
               else if( mTryTimes == 4 ) mAccountBalance=mAccountBalance-mInvestment4;
               else if( mTryTimes == 5 ) mAccountBalance=mAccountBalance-mInvestment5;
              }
            else
              {
               mAccountBalance=mAccountBalance-mInvestment;
              }
           }
        }
      else
        {
         // Print (" Trading out of hours");
        }
     }

// Avoid having two trades in the same candle
   if(mAskForPendingReset)
     {
      mBetPending=false;
      mAskForPendingReset=false;
     }

//***********
// Draw the HMI with all indications for EA efficiency
//**********
   displayHMI();

  }
//+------------------------------------------------------------------+
//| Reset all variables                                                 |
//+------------------------------------------------------------------+
void resetVariables()
  {
   mBetStatus="";
   mPutPrice=0.0;
   mCallPrice=0.0;
  }
//+------------------------------------------------------------------+
//| Display HMI on Chart window                                              |
//+------------------------------------------------------------------+
void displayHMI()
  {
   displayText("Balance  : "+DoubleToStr(mAccountBalance,2),1,clrYellow);
   displayText("Wins     : "+IntegerToString(mNbWins),2,clrYellow);
   displayText("Losses   : "+IntegerToString(mNbLoss),3,clrYellow);
   displayText("Draws    : "+IntegerToString(mNbDraws),4,clrYellow);
   displayText("Consec. W/L : "+IntegerToString(mMaxConsecutivesWins)+"/"+IntegerToString(mMaxConsecutivesLosses),5,clrYellow);

   double ltotal=mNbWins+mNbLoss+mNbDraws;
   if(ltotal!=0)
     {
      double lWinRate=mNbWins/(ltotal-mNbDraws)*100.0;
      displayText("Win Rate : "+DoubleToStr(lWinRate,2)+" %",6,clrYellow);
     }
   else
     {
      displayText("Win Rate : "+DoubleToStr(0.0,2)+" %",6,clrYellow);
     }
  }
//+------------------------------------------------------------------+
//| Display Journal in the log window to avoid using visual mode     |
//+------------------------------------------------------------------+
void displayJournal()
  {
   double ltotal=mNbWins+mNbLoss+mNbDraws;
   double lWinRate=0.0;
   if(ltotal!=0)
     {
      lWinRate=mNbWins/(ltotal-mNbDraws)*100.0;
     }
   Print(" Balance : "+DoubleToStr(mAccountBalance)+" Wins : "+IntegerToString(mNbWins)+" Losses : "+IntegerToString(mNbLoss)+" Draws : "+IntegerToString(mNbDraws)+" Win Rate : "+DoubleToStr(lWinRate,2));
  }
//
//*********
// UTILITIES FUNCTIONS
//********
//

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
bool New_Bar()
  {
   if(New_Time!=iTime(Symbol(),Period(),0))
     {
      New_Time=iTime(Symbol(),Period(),0);
      return(true);
     }
   else return(false);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void drawArrowDown()
  {
   ObjectCreate("Down"+IntegerToString(mSellOrderObjectsNumber),OBJ_ARROW_DOWN,0,Time[mCandleElapsed],High[mCandleElapsed]+10*Point);
   ObjectSetInteger(ChartID(),"Down"+IntegerToString(mSellOrderObjectsNumber),OBJPROP_COLOR,clrYellow);
   ObjectSet("Down"+IntegerToString(mSellOrderObjectsNumber),OBJPROP_WIDTH,2);
   mSellOrderObjectsNumber++;
  }
//+------------------------------------------------------------------+
void drawArrowUp()
  {
   ObjectCreate("Up"+IntegerToString(mBuyOrderObjectsNumber),OBJ_ARROW_UP,0,Time[mCandleElapsed],Low[mCandleElapsed]-5*Point);
   ObjectSetInteger(ChartID(),"Up"+IntegerToString(mBuyOrderObjectsNumber),OBJPROP_COLOR,clrTurquoise);
   ObjectSet("Up"+IntegerToString(mBuyOrderObjectsNumber),OBJPROP_WIDTH,2);
   mBuyOrderObjectsNumber++;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void drawArrowStop(bool pDrawTop)
  {
   double lObjectPrice;
   if(pDrawTop) lObjectPrice=High[1]+8.0*Point;
   else lObjectPrice=Low[1]-5.0*Point;

   mObjectsArrowStopNumber++;
   if(!ObjectCreate(ChartID(),"Stop"+IntegerToString(mObjectsArrowStopNumber),OBJ_ARROW_STOP,0,Time[1],lObjectPrice))
     {
      Print("Error: can't create label! code #",GetLastError());
     }
   else
     {
      ObjectSet("Stop"+IntegerToString(mObjectsArrowStopNumber),OBJPROP_COLOR,clrRed);
      ObjectSet("Stop"+IntegerToString(mObjectsArrowStopNumber),OBJPROP_WIDTH,2);
      ObjectSet("Stop"+IntegerToString(mObjectsArrowStopNumber),OBJPROP_BACK,false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void drawArrowCheck(bool pDrawTop)
  {
   double lObjectPrice;
   if(pDrawTop) lObjectPrice=High[1]+8.0*Point;
   else lObjectPrice=Low[1]-5.0*Point;
   mObjectsArrowCheckNumber++;
   if(!ObjectCreate(ChartID(),"Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJ_ARROW_CHECK,0,Time[1],lObjectPrice))
     {
      Print("Error: can't create label! code #",GetLastError());
     }
   else
     {
      ObjectSet("Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJPROP_COLOR,clrGold);
      ObjectSet("Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJPROP_WIDTH,2);
      ObjectSet("Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJPROP_BACK,false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void drawDraw(bool pDrawTop)
  {
   double lObjectPrice;
   if(pDrawTop) lObjectPrice=High[1]+8.0*Point;
   else lObjectPrice=Low[1]-5.0*Point;
   mObjectsArrowCheckNumber++;
   if(!ObjectCreate(ChartID(),"Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJ_ARROW_STOP,0,Time[1],lObjectPrice))
     {
      Print("Error: can't create label! code #",GetLastError());
     }
   else
     {
      ObjectSet("Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJPROP_COLOR,clrBlue);
      ObjectSet("Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJPROP_WIDTH,2);
      ObjectSet("Pouce"+IntegerToString(mObjectsArrowCheckNumber),OBJPROP_BACK,false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+ 
void drawEntryLine(bool pIsCall)
  {
   string objName="Line"+IntegerToString(mLineObjectsNumber);
   if(!ObjectCreate(ChartID(),objName,OBJ_RECTANGLE,0,Time[1],Bid,Time[0],Bid))
     {
      Print(" Creation of line yellow failed : "+IntegerToString(GetLastError()));
     }
   else
     {
      mLineObjectsNumber++;
      if(pIsCall)
        {
         ObjectSetInteger(ChartID(),objName,OBJPROP_COLOR,clrBlue);
         ObjectSetInteger(ChartID(),objName,OBJPROP_BGCOLOR,clrBlue);
        }
      else
        {
         ObjectSetInteger(ChartID(),objName,OBJPROP_COLOR,clrYellow);
         ObjectSetInteger(ChartID(),objName,OBJPROP_BGCOLOR,clrYellow);
        }
      ObjectSetInteger(ChartID(),objName,OBJPROP_BACK,false);
      ObjectSetInteger(ChartID(),objName,OBJPROP_WIDTH,2);

     }
  }
//+------------------------------------------------------------------+
void displayText(string pText,int pPosition,color pColor=clrWhite)
  {
   string obj_name="Text"+IntegerToString(pPosition);

   ObjectCreate(ChartID(),obj_name,OBJ_LABEL,0,0,0);
   ObjectSetString(ChartID(),obj_name,OBJPROP_TEXT,pText);
   ObjectSet(obj_name,OBJPROP_XDISTANCE,10.0);
   ObjectSet(obj_name,OBJPROP_YDISTANCE,pPosition*15.0+30.0);
   ObjectSet(obj_name,OBJPROP_COLOR,pColor);
  }
//+------------------------------------------------------------------+
void displayTextRight(string pText,int pRightPosition,color pColor=clrWhite)
  {
   string obj_name="TextRight"+IntegerToString(pRightPosition);

   ObjectCreate(ChartID(),obj_name,OBJ_LABEL,0,0,0);
   ObjectSetString(ChartID(),obj_name,OBJPROP_TEXT,pText);
   ObjectSetInteger(ChartID(),obj_name,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   ObjectSet(obj_name,OBJPROP_XDISTANCE,-50.0);
   ObjectSet(obj_name,OBJPROP_YDISTANCE,pRightPosition*20.0);
   ObjectSet(obj_name,OBJPROP_COLOR,pColor);
  }
//+------------------------------------------------------------------+
void displayTextDownLeft(string pText,int pPosition,color pColor=clrWhite)
  {
   string obj_name="TextDown"+IntegerToString(pPosition);

   ObjectCreate(ChartID(),obj_name,OBJ_LABEL,0,0,0);
   ObjectSetString(ChartID(),obj_name,OBJPROP_TEXT,pText);
   ObjectSet(obj_name,OBJPROP_CORNER,CORNER_LEFT_LOWER);
   ObjectSet(obj_name,OBJPROP_XDISTANCE,10.0);
   ObjectSet(obj_name,OBJPROP_YDISTANCE,pPosition*20.0);
   ObjectSet(obj_name,OBJPROP_COLOR,pColor);
  }
//+------------------------------------------------------------------+

